// Copyright (c) 2017, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

part of editex;

/// Command data
class EdiTeXCommand {
  final String name, parseTemplate;
  final LaTeXTemplate template;

  EdiTeXCommand(this.name, this.template, this.parseTemplate);
}

/// Interface functions
abstract class EdiTeXInterface {
  bool hasCommand(String command);
  bool hasInstantCommand(String command);
  EdiTeXCommand resolveCommand(String command);
  EdiTeXCommand resolveInstantCommand(String command);
}

/// Passing null to [parseLaTeXTemplate] is not very nice, but it is supposed to
/// work.
final _subSupCommand = new EdiTeXCommand(
    'subsup', parseLaTeXTemplate(r'_{${0}}^{${1}}', null), r'_($0)^($1)');
